package com.ntut.csie.game.core;

import java.io.IOException;

import com.ntut.csie.game.GameView;

import android.content.res.AssetFileDescriptor;
import android.media.MediaPlayer;

public class Audio {
	private MediaPlayer mAudio;
	
	public Audio() {}
	
	public Audio(int resId) {
		SetResource(resId);
	}
	
	public Audio(String fileName) {
        SetResource(fileName);
    }
	
	public void SetResource(int resId) {
		mAudio = MediaPlayer.create(GameView.mContext, resId);
		mAudio.setVolume(2, 2);
	}
	
	public void SetResource(String fileName) {
		try {
			AssetFileDescriptor afd = GameView.mContext.getAssets().openFd(fileName);
			mAudio = new MediaPlayer();
			mAudio.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
			mAudio.prepare();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void Play() {
		mAudio.seekTo(0);
		mAudio.start();
	}
	
	public void Stop() {
		mAudio.pause();
	}
	
	public void Pause() {
		mAudio.pause();
	}
	
	public void Resume() {
		mAudio.start();
	}
	
	public void SetLooping(boolean looping) {
		mAudio.setLooping(looping);
	}
	
	public void Release() {
		if(mAudio != null) {
			mAudio.stop();
			mAudio.release();
			mAudio = null;
		}
	}
}
