package com.ntut.csie.game.extend;

import com.ntut.csie.game.R;
import com.ntut.csie.game.core.MovingBitmap;

public class Integer {
	private int mInteger;
	private int mNumOfDigit = 4;
	private int mX;
	private int mY; 
	private MovingBitmap[] mDigit = new MovingBitmap[11];
	
	public Integer() {
		SetResource();
	}
	
	public Integer(int digits) {
		SetNumOfDigit(digits);
		SetResource();
	}
	
	public void SetNumOfDigit(int digits) {
		mNumOfDigit = digits;
	}
	
	public void SetResource() {
		mDigit = new MovingBitmap[11];
		for(int i = 0; i < 11 ; i++)
			mDigit[i] = new MovingBitmap();
		mDigit[0].SetResource(R.drawable.digit_0);
		mDigit[1].SetResource(R.drawable.digit_1);
		mDigit[2].SetResource(R.drawable.digit_2);
		mDigit[3].SetResource(R.drawable.digit_3);
		mDigit[4].SetResource(R.drawable.digit_4);
		mDigit[5].SetResource(R.drawable.digit_5);
		mDigit[6].SetResource(R.drawable.digit_6);
		mDigit[7].SetResource(R.drawable.digit_7);
		mDigit[8].SetResource(R.drawable.digit_8);
		mDigit[9].SetResource(R.drawable.digit_9);
		mDigit[10].SetResource(R.drawable.digit_10);
	}
	
	public void SetXY(int x, int y) {
		mX = x;
		mY = y;
	}
	
	public void OnShow() {
		int nx;
		int MSB;
		if (mInteger >= 0) {
			MSB = mInteger;
			nx = mX + mDigit[0].GetHeight()*(mNumOfDigit - 1);
		} else {
			MSB = - mInteger;
			nx = mX + mDigit[0].GetWidth()*mNumOfDigit;
		}
		for (int i = 0; i < mNumOfDigit; i++) {
			int d = MSB % 10;
			MSB /= 10;
			mDigit[d].SetXY(nx, mY);
			mDigit[d].OnShow();
			nx -= mDigit[d].GetWidth();
		}
		if (mInteger < 0) {
			mDigit[10].SetXY(nx, mY);
			mDigit[10].OnShow();
		}
	}
	
	public void Add(int n) {
		mInteger += n;
	}
	
	public void Subtract(int n) {
		mInteger -= n;
	}
	
	public void SetInteger(int n) {
		mInteger = n;
	}
	
	public int GetInteger() {
		return mInteger;
	}
	
	public void Release() {
		for(int i = 0; i < 11; i++) {
			mDigit[i].Release();
		}
	}
}
